﻿Imports System.Data.Odbc
Imports System.IO
Imports System.Text

Public Class F_初期設定
    Public con_str As String = ""
    Public acfile As String = ""

    Private Sub F_初期設定_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim w_sql As String
        Dim res As String

        Me.KeyPreview = True        'キーボードイベント取得

        Try
            '※ODBC接続文字列取得
            Dim sb1_1 As StringBuilder = New StringBuilder(300)
            Dim unused = common.GetPrivateProfileString("ODBC", "conn", "none", sb1_1, Convert.ToUInt32(sb1_1.Capacity), ".\eform.ini")
            If sb1_1.ToString <> "" Then
                con_str = sb1_1.ToString
            End If

            'Accessファイル
            Dim sb1_2 As StringBuilder = New StringBuilder(300)
            common.GetPrivateProfileString("ODBC", "acfile", "none", sb1_2, Convert.ToUInt32(sb1_2.Capacity), ".\eform.ini")
            If sb1_2.ToString <> "" Then
                acfile = sb1_2.ToString
            End If

            If con_str = "" And acfile <> "" Then
                con_str = "Driver={Microsoft Access Driver (*.mdb, *.accdb)};DBQ=" & acfile & "; Uid=; Pwd =;"
            End If

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            Close()
            'Return
        End Try

        If con_str = Nothing Then
            res = MsgBox("ODBCが設定されていません。設定してください。", vbExclamation)
            Close()

        Else
            Try
                Using Conn As New OdbcConnection(con_str)

                    'DB接続
                    Conn.Open()

                    'コントロールテーブル参照
                    w_sql = "SELECT * FROM ef_cnt_tbl WHERE id='1';"

                    id.Text = ""
                    背景色.Text = 15781060

                    ' 読み込み
                    Dim oc = New OdbcCommand(w_sql, Conn)
                    Dim odr = oc.ExecuteReader()
                    While odr.Read() = True

                        id.Text = odr("id")
                        syamei.Text = odr("syamei")
                        yubin.Text = odr("yubin").ToString
                        ju1.Text = odr("ju1").ToString
                        ju2.Text = odr("ju2").ToString
                        tel.Text = odr("tel").ToString
                        fax.Text = odr("fax").ToString
                        Me.背景色.Text = odr("bcolor")
                        保存フォルダ.Text = odr("save_fold").ToString

                        Me.Text = "初期設定 - " + syamei.Text

                        '背景色 Access側 10進数からRGB算出
                        Dim w_color = odr("bcolor")
                        Dim w_blue = Math.Truncate(w_color / 65536)
                        Dim w_green = Math.Truncate((w_color - 65536 * w_blue) / 256)
                        Dim w_red = w_color - (65536 * w_blue) - (256 * w_green)
                        Me.BackColor = Color.FromArgb(w_red, w_green, w_blue)


                    End While

                    odr.Close()
                    oc.Dispose()

                End Using

            Catch ex As Exception
                MessageBox.Show(Err.Description)
                Close()
                'Return
            End Try

        End If

    End Sub

    Private Sub btn_閉じる_Click(sender As Object, e As EventArgs) Handles btn_閉じる.Click

        Close()

    End Sub

    Private Sub btn_背景色_Click(sender As Object, e As EventArgs) Handles btn_背景色.Click
        Using dialog As New ColorDialog()
            ' プロパティの設定
            With dialog
                ' カスタムカラーを定義可能にする
                .AllowFullOpen = True

                ' カスタムカラーの作成用のコントロールを表示する
                .FullOpen = True

                ' 初期値の色を設定する
                .Color = Me.BackColor
            End With

            ' ダイアログを表示し、戻り値が [OK] の場合は、選択したフォルダ名を表示する
            If dialog.ShowDialog() = DialogResult.OK Then
                ' 色を設定する
                Me.BackColor = dialog.Color
                Dim w_blue = Me.BackColor.B
                Dim w_green = Me.BackColor.G
                Dim w_red = Me.BackColor.R
                '256*256*青の数値 + 256*緑の数値 + 赤の数値 VBA
                Me.背景色.Text = 256 * 256 * w_blue + 256 * w_green + w_red
                Me.背景色2.Text = dialog.Color.ToString
            End If
        End Using
    End Sub

    Private Sub btn_書込み_Click(sender As Object, e As EventArgs) Handles btn_書込み.Click
        Dim w_sql As String
        Dim res As String

        保存フォルダ.Text = common.Nz(保存フォルダ.Text)

        Try
            Using Conn As New OdbcConnection(con_str)

                'DB接続
                Conn.Open()

                ' 読み込み
                Dim oc As OdbcCommand

                '-- 新規
                If id.Text = "" Then
                    w_sql = "INSERT INTO ef_cnt_tbl ("
                    w_sql = w_sql & "id,syamei,yubin,ju1,ju2,tel,fax, bcolor"
                    w_sql = w_sql & ",save_fold"
                    w_sql = w_sql & ") "
                    w_sql = w_sql & " VALUES("
                    w_sql = w_sql & "'1','" & common.Nz(syamei.Text) & "'"
                    w_sql = w_sql & ",'" & common.Nz(yubin.Text) & "','" & common.Nz(ju1.Text) & "','" & common.Nz(ju2.Text) & "'"
                    w_sql = w_sql & ",'" & common.Nz(tel.Text) & "','" & common.Nz(fax.Text) & "'"
                    w_sql = w_sql & "," & common.Nz(CDbl(背景色.Text), 15781060)
                    w_sql = w_sql & ",'" & 保存フォルダ.Text & "'"
                    w_sql = w_sql & ");"
                Else
                    '更新
                    w_sql = "UPDATE ef_cnt_tbl SET syamei='" & syamei.Text & "' "
                    w_sql = w_sql & ",yubin='" & yubin.Text.ToString & "' "
                    w_sql = w_sql & ",ju1='" & ju1.Text.ToString & "' "
                    w_sql = w_sql & ",ju2='" & ju2.Text.ToString & "' "
                    w_sql = w_sql & ",tel='" & tel.Text.ToString & "' "
                    w_sql = w_sql & ",fax='" & fax.Text.ToString & "' "
                    w_sql = w_sql & ",bcolor=" & CDbl(背景色.Text)
                    w_sql = w_sql & ",save_fold='" & 保存フォルダ.Text & "'"
                    w_sql = w_sql & " WHERE id='1'"
                    w_sql = w_sql & ";"
                End If

                oc = New OdbcCommand(w_sql, Conn)

                res = oc.ExecuteNonQuery()

                oc.Dispose()

            End Using

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            Return
        End Try

        res = MsgBox("書き込みました。", vbInformation)

        Me.Close()

    End Sub

    Private Sub F_初期設定_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        Dim forward As Boolean

        If e.KeyCode = Keys.Enter Then
            ' Shiftキーが押されているかの判定
            forward = e.Modifiers <> Keys.Shift
            ' タブオーダー順で次のコントロールにフォーカスを移動
            Me.SelectNextControl(Me.ActiveControl, forward, True, True, True)
        End If

    End Sub

    Private Sub F_初期設定_KeyPress(sender As Object, e As KeyPressEventArgs) Handles MyBase.KeyPress
        If e.KeyChar = ControlChars.Cr Then
            '[Enter]キーで音が出るので、キーイベントが処理されたことにして音を消す
            e.Handled = True
        End If
    End Sub

    Private Sub btn_参照_Click(sender As Object, e As EventArgs) Handles btn_参照.Click
        Dim Ret As DialogResult


        Try

            Using Dialog As New FolderBrowserDialog()

                If Directory.Exists(保存フォルダ.Text) Then
                    'フォルダを選択済みの場合はそこをデフォルトにする
                    Dialog.SelectedPath = 保存フォルダ.Text
                End If

                With Dialog
                    .Description = "フォルダを選択してください。"
                End With

                Ret = Dialog.ShowDialog()

                If Ret = DialogResult.OK Then

                    保存フォルダ.Text = Dialog.SelectedPath

                End If

            End Using

        Catch ex As Exception

            MessageBox.Show(Err.Description)

        End Try
    End Sub
End Class