﻿Imports System.Data.Odbc
Imports System.IO
Imports System.Text

Public Class Form1
    Public con_str As String = ""
    Public acfile As String = ""

    Private Sub cmd_ファイル選択_Click(sender As Object, e As EventArgs) Handles cmd_ファイル選択.Click
        ' ダイアログボックスの表示
        OpenFileDialog1.Filter = "PDF|*.pdf"
        If OpenFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            '// 選択されたファイルをテキストボックスに表示する
            ファイル名.Text = OpenFileDialog1.FileName
            '// PDFファイルを開く
            AxAcroPDF1.LoadFile(ファイル名.Text)
            '// ファイルハッシュ値取得
            hash値.Text = common.GetFHashValue(ファイル名.Text)
        End If

    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Me.KeyPreview = True        'キーボードイベント取得

        Dim w_sql As String

        Try
            '※ODBC接続文字列取得
            Dim sb1_1 As StringBuilder = New StringBuilder(300)
            Dim unused = common.GetPrivateProfileString("ODBC", "conn", "none", sb1_1, Convert.ToUInt32(sb1_1.Capacity), ".\eform.ini")
            If sb1_1.ToString <> "" Then
                con_str = sb1_1.ToString
            End If

            'Accessファイル
            Dim sb1_2 As StringBuilder = New StringBuilder(300)
            common.GetPrivateProfileString("ODBC", "acfile", "none", sb1_2, Convert.ToUInt32(sb1_2.Capacity), ".\eform.ini")
            If sb1_2.ToString <> "" Then
                acfile = sb1_2.ToString
            End If

            If con_str = "" And acfile <> "" Then
                con_str = "Driver={Microsoft Access Driver (*.mdb, *.accdb)};DBQ=" & acfile & "; Uid=; Pwd =;"
            End If

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            Close()
            'Return
        End Try

        Try
            Using Conn As New OdbcConnection(con_str)

                'DB接続
                Conn.Open()

                'コントロールテーブル参照
                w_sql = "SELECT * FROM ef_cnt_tbl"

                ' 読み込み
                Dim oc = New OdbcCommand(w_sql, Conn)
                Dim odr = oc.ExecuteReader()
                While odr.Read() = True

                    Me.Text = "電子帳票登録 - " & odr("syamei").ToString
                    保存場所.Text = odr("save_fold")

                    '背景色 Access側 10進数からRGB算出
                    Dim w_color = odr("bcolor")
                    Dim w_blue = Math.Truncate(w_color / 65536)
                    Dim w_green = Math.Truncate((w_color - 65536 * w_blue) / 256)
                    Dim w_red = w_color - (65536 * w_blue) - (256 * w_green)
                    Me.BackColor = Color.FromArgb(w_red, w_green, w_blue)

                End While

                odr.Close()
                oc.Dispose()

            End Using

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            Close()
            'Return
        End Try


        '--- 取引先名・支払先名コンボデータソースセット
        comb_ini()

        value_ini()


    End Sub

    Private Sub cmd_終了_Click(sender As Object, e As EventArgs) Handles cmd_終了.Click

        Close()

    End Sub

    Public Sub comb_ini()
        '--- 取引先名・支払先名のコンボのソースをeform_info_dのデータよりセット ---
        Dim w_sql As String
        Dim dt As DataTable
        Dim dt2 As DataTable

        Dim connection = New OdbcConnection(con_str)
        Dim adapter As OdbcDataAdapter

        Try

            'DB接続
            connection.Open()

            ' --- 取引先名 -----
            w_sql = "SELECT torinm FROM eform_info_d WHERE torinm <>'' "
            w_sql &= " AND sysskbn <> '削除' "
            w_sql &= " GROUP BY torinm ORDER BY torinm"
            w_sql &= ";"
            dt = New DataTable()

            '// 読み込み
            adapter = New OdbcDataAdapter(w_sql, connection)
            adapter.Fill(dt)

            取引先名.DataSource = dt    '// 取引先名コンボソース

            adapter.Dispose()

            'データ用の列を設定
            取引先名.ValueMember = "torinm"
            取引先名.Text = ""

            ' 支払先名
            w_sql = "SELECT sihanm FROM eform_info_d WHERE sihanm <>'' "
            w_sql &= " AND sysskbn <> '削除' "
            w_sql &= " GROUP BY sihanm ORDER BY sihanm"
            w_sql &= ";"
            dt2 = New DataTable()

            '// 読み込み
            adapter = New OdbcDataAdapter(w_sql, connection)
            adapter.Fill(dt2)

            支払先名.DataSource = dt2    '// 支払先名取引先名コンボソース

            adapter.Dispose()

            'データ用の列を設定
            支払先名.ValueMember = "sihanm"
            支払先名.Text = ""

            ' --システム名 コンボ -----
            w_sql = "SELECT sysnm FROM eform_info_d WHERE  "
            w_sql &= " sysskbn <> '削除' "
            w_sql &= " GROUP BY sysnm ORDER BY sysnm"
            w_sql &= ";"
            dt2 = New DataTable()

            '// 読み込み
            adapter = New OdbcDataAdapter(w_sql, connection)
            adapter.Fill(dt2)

            システム名.DataSource = dt2    '// コンボソース

            adapter.Dispose()

            'データ用の列を設定
            システム名.ValueMember = "sysnm"
            システム名.Text = ""


            'DB切断
            connection.Close()

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            'Close()
            Return
        End Try

    End Sub

    Private Sub ファイル名_DragDrop(sender As Object, e As DragEventArgs) Handles ファイル名.DragDrop
        If e.Data.GetDataPresent(DataFormats.FileDrop) = False Then Exit Sub

        Dim dragFilePathArr As String() = e.Data.GetData(DataFormats.FileDrop, False)
        ファイル名.Text = dragFilePathArr(0)

        '// PDFファイルを開く
        AxAcroPDF1.LoadFile(ファイル名.Text)

        '// ハッシュ値取得
        hash値.Text = common.GetFHashValue(ファイル名.Text)

    End Sub

    Private Sub ファイル名_DragEnter(sender As Object, e As DragEventArgs) Handles ファイル名.DragEnter
        e.Effect = DragDropEffects.All
    End Sub

    Private Sub value_ini()
        Try
            AxAcroPDF1.LoadFile("dummy_dummy_.pdf")        '空表示させるため、わざと存在しないファイルを指定
            ファイル名.Text = ""
            取引先名.Text = ""
            支払先名.Text = ""
            金額.Text = 0
            biko.Text = ""
            Ref_no.Text = ""
            システム名.Text = ""
            伝票No.Text = ""
            hash値.Text = ""
        Catch ex As Exception
            MessageBox.Show(Err.Description)
            'Close()
            Return
        End Try

    End Sub

    Private Sub cmd_キャンセル_Click(sender As Object, e As EventArgs) Handles cmd_キャンセル.Click

        value_ini()

    End Sub

    Private Sub cmd_登録_Click(sender As Object, e As EventArgs) Handles cmd_登録.Click

        Dim res As String
        Dim w_sql As String
        Dim w_lenban As Long
        Dim w_str As String
        Dim w_uptime As String

        Dim oc As OdbcCommand
        Dim odr As OdbcDataReader
        Dim cmd As OdbcCommand

        'トランザクション
        Dim trn As OdbcTransaction

        '// 入力チェック
        取引先名.Text = common.Nz(取引先名.Text, "")
        If 取引先名.Text = "" Then
            res = MsgBox("取引先は省略できません。", vbExclamation)
            Exit Sub
        End If

        If ファイル名.Text = "" Then
            res = MsgBox("ファイルは省略できません。", vbExclamation)
            Exit Sub
        End If

        'Null値対策
        支払先名.Text = common.Nz(支払先名.Text, "")
        biko.Text = common.Nz(biko.Text, "")
        システム名.Text = common.Nz(システム名.Text, "")
        伝票No.Text = common.Nz(伝票No.Text, "")


        '// ----- データ出力 -------------------------------

        w_lenban = 0

        Using Conn As New OdbcConnection(con_str)
            'DB接続
            Conn.Open()

            '連番取得
            Try
                'w_sql = "select nextval('eform_info_d_rno_seq')"               'PostgreSQL seq使用の場合
                w_sql = "select max(rno) as max_rno from eform_info_d;"

                oc = New OdbcCommand(w_sql, Conn)
                odr = oc.ExecuteReader()
                While odr.Read() = True
                    'w_lenban = odr("nextval")
                    w_lenban = common.Nz(odr("max_rno"), 0) + 1
                End While

                odr.Close()
                oc.Dispose()

            Catch ex As Exception
                MessageBox.Show(Err.Description)
                'Close()
                Return

            End Try

            'トランザクション開始
            trn = Conn.BeginTransaction

            Try
                '--- データ追加
                w_sql = "INSERT INTO eform_info_d ("
                w_sql = w_sql & "rno,ymd,torinm,sihanm,kin,fnm,sysnm,sysdno,sysskbn,biko,entymd,entterm,upymd,upterm "
                w_sql = w_sql & ") "
                w_sql = w_sql & " VALUES("
                w_sql = w_sql & w_lenban & ", '" & dateTimePicker1.Value.ToString("yyyy/MM/dd")
                w_sql = w_sql & "','" & 取引先名.Text & "','" & 支払先名.Text & "' "
                w_sql = w_sql & "," & CDbl(金額.Text) & ",'" & w_lenban & "_" & Path.GetFileName(ファイル名.Text) & "'"
                w_sql = w_sql & ",'" & システム名.Text & "','" & 伝票No.Text & "'"
                w_sql = w_sql & ", '新規','" & biko.Text & "'"
                w_uptime = Format(Now(), "yyyy/MM/dd HH:mm:ss")
                w_str = Environment.MachineName
                w_sql = w_sql & ", '" & w_uptime & "', '" & w_str & "_VB', '" & w_uptime & "', '" & w_str & "_VB'"
                w_sql = w_sql & ")"

                cmd = New OdbcCommand(w_sql, Conn)

                'sqlコマンドをトランザクションに適用
                cmd.Transaction = trn

                res = cmd.ExecuteNonQuery()

                ''--- hash値データ追加　未使用 ------------
                'w_sql = "INSERT INTO eform_hash_d ("
                'w_sql = w_sql & "eno,fnm,hash,entymd,entterm "
                'w_sql = w_sql & ") "
                'w_sql = w_sql & " VALUES("
                'w_sql = w_sql & w_lenban & ", '" & w_lenban & "_" & Path.GetFileName(ファイル名.Text) & "'"
                'w_sql = w_sql & ", '" & hash値.Text & "'"
                'w_str = Environment.MachineName
                'w_sql = w_sql & ", '" & w_uptime & "', '" & w_str & "_VB'"
                'w_sql = w_sql & ")"

                'cmd = New OdbcCommand(w_sql, Conn)

                ''sqlコマンドをトランザクションに適用
                'cmd.Transaction = trn

                'res = cmd.ExecuteNonQuery()

                '-----------------------------------------

                ' // ファイルコピー
                w_str = 保存場所.Text & "\\" & w_lenban & "_" & Path.GetFileName(ファイル名.Text)
                File.Copy(ファイル名.Text, w_str)

                '反映
                trn.Commit()

                cmd.Dispose()

                'DB切断
                Conn.Close()


            Catch ex As Exception
                MessageBox.Show(Err.Description)

                'ロールバック
                trn.Rollback()
                MessageBox.Show("登録を中止しました。")

                'Close()
                Return

            End Try

        End Using

        res = MsgBox("登録しました。", vbInformation)

        dateTimePicker1.Select()
        dateTimePicker1.Focus()

        '--- 取引先名・支払先名コンボデータソースセット
        comb_ini()

        '初期化
        value_ini()


    End Sub

    Private Sub cmd_問合せ_Click(sender As Object, e As EventArgs) Handles cmd_問合せ.Click
        Dim f2 As Form = New Form2()
        f2.Show()
    End Sub

    Private Sub btn_日付参照_Click(sender As Object, e As EventArgs) Handles btn_日付参照.Click
        Dim f_cal As Form = New F_カレンダー()

        cal.p_ymd = dateTimePicker1.Value
        f_cal.StartPosition = FormStartPosition.CenterParent

        If DialogResult.OK = f_cal.ShowDialog(Me) Then
            Dim re_ymd As Date = cal.p_ymd
            'MessageBox.Show(re_ymd.ToString("yyyy/MM/dd"))
            dateTimePicker1.Value = re_ymd
        End If

        f_cal.Dispose()

    End Sub

    Private Sub Form1_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        Dim forward As Boolean

        If e.KeyCode = Keys.Enter Then
            ' Shiftキーが押されているかの判定
            forward = e.Modifiers <> Keys.Shift
            ' タブオーダー順で次のコントロールにフォーカスを移動
            Me.SelectNextControl(Me.ActiveControl, forward, True, True, True)
        End If

    End Sub

    Private Sub Form1_KeyPress(sender As Object, e As KeyPressEventArgs) Handles MyBase.KeyPress
        If e.KeyChar = ControlChars.Cr Then
            '[Enter]キーで音が出るので、キーイベントが処理されたことにして音を消す
            e.Handled = True
        End If
    End Sub

    Private Sub 金額_Enter(sender As Object, e As EventArgs) Handles 金額.Enter

        金額.Text = CDbl(金額.Text)

    End Sub

    Private Sub 金額_Leave(sender As Object, e As EventArgs) Handles 金額.Leave

        If Not IsNumeric(金額.Text) Then
            金額.Text = 0
        End If

        金額.Text = Format(CDbl(金額.Text), "#,##0")

    End Sub

    Private Sub Btn_参照_Click(sender As Object, e As EventArgs) Handles Btn_参照.Click
        Dim f_sh As Form = New F_参照()
        Dim w_sql As String
        Dim w_str As String

        common.p_no = 0
        Ref_no.Text = ""

        f_sh.StartPosition = FormStartPosition.CenterParent

        If DialogResult.OK = f_sh.ShowDialog(Me) Then
            Ref_no.Text = common.p_no.ToString

            Try
                Using Conn As New OdbcConnection(con_str)
                    '// --- データ取得・表示 -----------------
                    w_sql = "SELECT * FROM eform_info_d WHERE rno=" & Convert.ToInt64(Ref_no.Text)
                    Conn.Open()

                    Dim oc = New OdbcCommand(w_sql, Conn)
                    Dim odr = oc.ExecuteReader()

                    oc = New OdbcCommand(w_sql, Conn)
                    odr = oc.ExecuteReader()
                    While odr.Read() = True
                        取引先名.Text = odr("torinm")
                        支払先名.Text = odr("sihanm")
                        金額.Text = CDbl(odr("kin")).ToString("#,##0")
                        biko.Text = odr("biko")
                        ファイル名.Text = odr("fnm")
                        dateTimePicker1.Value = DateTime.Parse(odr("ymd"))
                        システム名.Text = odr("sysnm")
                        伝票No.Text = odr("sysdno")
                    End While

                    odr.Close()
                    oc.Dispose()

                    Conn.Close()

                    w_str = 保存場所.Text & "\\" & ファイル名.Text

                    AxAcroPDF1.LoadFile(w_str)

                    '// ファイルハッシュ値取得
                    hash値.Text = common.GetFHashValue(w_str)

                    dateTimePicker1.Select()
                    dateTimePicker1.Focus()

                    ファイル名.Text = ""

                End Using

            Catch ex As Exception
                MessageBox.Show(Err.Description)
                'Close()
                Return

            End Try

        End If

        f_sh.Dispose()

    End Sub

    Private Sub 取引先名_Leave(sender As Object, e As EventArgs) Handles 取引先名.Leave
        Dim w_str As String

        '全角文字に統一
        w_str = common.Nz(取引先名.Text, "")
        w_str = StrConv(w_str, vbWide)
        取引先名.Text = w_str

    End Sub

    Private Sub 支払先名_Leave(sender As Object, e As EventArgs) Handles 支払先名.Leave
        Dim w_str As String

        '全角文字に統一
        w_str = common.Nz(支払先名.Text, "")
        w_str = StrConv(w_str, vbWide)
        支払先名.Text = w_str

    End Sub

    Private Sub Form1_FormClosed(sender As Object, e As FormClosedEventArgs) Handles MyBase.FormClosed

        common.p_form1_flg = False

    End Sub
End Class
