﻿Imports System.Data.Odbc
Imports System.Runtime.InteropServices
Imports System.Text

Public Class Form2
    '接続文字列　共通
    Public con_str As String = ""
    Public acfile As String = ""

    '明細表示専用データテーブル
    Public dt_rec As DataTable

    ' Excel処理関連定数
    Friend Const g_cnsExcelApplication As String = "Excel.Application"

    Private Sub Form2_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim w_sql As String

        Me.KeyPreview = True        'キーボードイベント取得

        ' データソース名セット
        Try
            '※ODBC接続文字列取得
            Dim sb1_1 As StringBuilder = New StringBuilder(300)
            Dim unused = common.GetPrivateProfileString("ODBC", "conn", "none", sb1_1, Convert.ToUInt32(sb1_1.Capacity), ".\eform.ini")
            If sb1_1.ToString <> "" Then
                con_str = sb1_1.ToString
            End If

            'Accessファイル
            Dim sb1_2 As StringBuilder = New StringBuilder(300)
            common.GetPrivateProfileString("ODBC", "acfile", "none", sb1_2, Convert.ToUInt32(sb1_2.Capacity), ".\eform.ini")
            If sb1_2.ToString <> "" Then
                acfile = sb1_2.ToString
            End If

            If con_str = "" And acfile <> "" Then
                con_str = "Driver={Microsoft Access Driver (*.mdb, *.accdb)};DBQ=" & acfile & "; Uid=; Pwd =;"
            End If

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            Close()
            'Return
        End Try

        Try
            Using connection As New OdbcConnection(con_str)
                'DB 接続
                connection.Open()

                'コントロールテーブル参照
                w_sql = "SELECT * FROM ef_cnt_tbl"

                Dim oc = New OdbcCommand(w_sql, connection)
                Dim odr = oc.ExecuteReader()

                While odr.Read() = True
                    Me.Text = "電子帳票問合せ - " + odr("syamei")
                    保存場所.Text = odr("save_fold")

                    '背景色 Access側 10進数からRGB算出
                    Dim w_color = odr("bcolor")
                    Dim w_blue = Math.Truncate(w_color / 65536)
                    Dim w_green = Math.Truncate((w_color - 65536 * w_blue) / 256)
                    Dim w_red = w_color - (65536 * w_blue) - (256 * w_green)
                    Me.BackColor = System.Drawing.Color.FromArgb(w_red, w_green, w_blue)
                End While

                odr.Close()
                oc.Dispose()

            End Using

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            Close()
            'Return
        End Try

        '--- 取引先名・支払先名コンボデータソースセット
        comb_ini()

        value_ini()

    End Sub

    Public Sub comb_ini()
        '--- 取引先名・支払先名のコンボのソースをeform_info_dのデータよりセット ---
        Dim w_sql As String
        Dim dt As DataTable
        Dim dt2 As DataTable


        Dim adapter As OdbcDataAdapter

        Try
            Using connection As New OdbcConnection(con_str)
                'DB 接続
                connection.Open()

                ' 取引先名
                w_sql = "SELECT torinm FROM eform_info_d WHERE torinm <>'' GROUP BY torinm ORDER BY torinm"
                dt = New DataTable()

                '// 読み込み
                adapter = New OdbcDataAdapter(w_sql, connection)
                adapter.Fill(dt)

                取引先名.DataSource = dt    '// 取引先名コンボソース

                adapter.Dispose()

                'データ用の列を設定
                取引先名.ValueMember = "torinm"
                取引先名.Text = ""


                ' --- 支払先名 ---
                w_sql = "SELECT sihanm FROM eform_info_d WHERE sihanm <>'' GROUP BY sihanm ORDER BY sihanm"
                dt2 = New DataTable()

                '// 読み込み
                adapter = New OdbcDataAdapter(w_sql, connection)
                adapter.Fill(dt2)

                支払先名.DataSource = dt2    '// 支払先名取引先名コンボソース

                adapter.Dispose()

                'データ用の列を設定
                支払先名.ValueMember = "sihanm"
                支払先名.Text = ""

                ' --システム名 コンボ -----
                w_sql = "SELECT sysnm FROM eform_info_d WHERE  "
                w_sql &= " sysskbn <> '削除' "
                w_sql &= " GROUP BY sysnm ORDER BY sysnm"
                w_sql &= ";"
                dt2 = New DataTable()

                '// 読み込み
                adapter = New OdbcDataAdapter(w_sql, connection)
                adapter.Fill(dt2)

                システム名.DataSource = dt2    '// コンボソース

                adapter.Dispose()

                'データ用の列を設定
                システム名.ValueMember = "sysnm"
                システム名.Text = ""


                adapter.Dispose()

                'DB 切断
                connection.Close()

            End Using

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            Close()
            'Return
        End Try


    End Sub

    Private Sub value_ini()

        取引日from.Text = ""
        取引日to.Text = ""
        取引先名.Text = ""
        支払先名.Text = ""
        金額from.Text = 0
        金額to.Text = 0
        システム名.Text = ""
        伝票No.Text = ""
        電子帳票No.Text = 0
        chk_削除表示.Checked = False

    End Sub

    Private Sub cmd_条件クリア_Click(sender As Object, e As EventArgs) Handles cmd_条件クリア.Click
        value_ini()
    End Sub

    Private Sub cmd_抽出_Click(sender As Object, e As EventArgs) Handles cmd_抽出.Click
        Dim w_sql As String

        If Not IsNumeric(電子帳票No.Text) Then
            電子帳票No.Text = 0
        End If

        w_sql = "SELECT rno,ymd,torinm,sihanm,kin,fnm,biko,sysnm,sysdno,entymd,entterm,sysskbn,upymd,upterm "
        w_sql = w_sql & "FROM eform_info_d WHERE rno > 0 "
        If chk_or.Checked = True Then
            w_sql = w_sql & "AND (torinm Like '%" & 取引先名.Text & "%' OR sihanm Like '%" & 支払先名.Text & "%') "
        Else
            If 取引先名.Text <> "" Then
                w_sql = w_sql & "AND (torinm Like '%" & 取引先名.Text & "%') "
            End If
            If 支払先名.Text <> "" Then
                w_sql = w_sql & "AND (sihanm Like '%" & 支払先名.Text & "%') "
            End If
        End If

        If 取引日from.Text <> "" Then
            w_sql = w_sql & "AND (ymd >='" & 取引日from.Text & "') "
        End If
        If 取引日to.Text <> "" Then
            w_sql = w_sql & "AND (ymd <='" & 取引日to.Text & "') "
        End If
        If CDbl(金額from.Text) <> 0 Then
            w_sql = w_sql & "AND (kin >=" & CDbl(金額from.Text) & ") "
        End If
        If CDbl(金額to.Text) <> 0 Then
            w_sql = w_sql & "AND (kin <=" & CDbl(金額to.Text) & ") "
        End If

        If システム名.Text <> "" Then
            w_sql = w_sql & "AND (sysnm Like '%" & システム名.Text & "%') "
        End If

        If Convert.ToInt64(電子帳票No.Text) <> 0 Then
            w_sql = w_sql & "AND (rno = " & Convert.ToInt64(電子帳票No.Text) & ") "
        End If

        If 伝票No.Text <> "" Then
            w_sql = w_sql & "AND (sysdno Like '%" & 伝票No.Text & "') "
        End If

        If chk_削除表示.Checked = False Then
            w_sql &= "AND (sysskbn <> '削除') "
        End If

        w_sql = w_sql & "Order By rno Desc"

        dt_rec = Nothing
        dt_rec = New DataTable()

        Dim adapter As OdbcDataAdapter

        Try
            Using Conn As New OdbcConnection(con_str)

                'DB 接続
                Conn.Open()


                '// 読み込み
                adapter = New OdbcDataAdapter(w_sql, Conn)
                adapter.Fill(dt_rec)

                '// DataGridへの表示　調整
                dataGridView1.DataSource = dt_rec

                dataGridView1.Columns(0).HeaderText = "No"
                dataGridView1.Columns(0).Width = 50
                dataGridView1.Columns(0).ReadOnly = True

                dataGridView1.Columns(1).HeaderText = "取引日"
                dataGridView1.Columns(1).Width = 80
                dataGridView1.Columns(2).HeaderText = "取引先"
                dataGridView1.Columns(2).Width = 200
                dataGridView1.Columns(3).HeaderText = "支払先"
                dataGridView1.Columns(3).Width = 80

                dataGridView1.Columns(4).HeaderText = "金額"
                dataGridView1.Columns(4).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
                dataGridView1.Columns(4).DefaultCellStyle.Format = "#,0"
                dataGridView1.Columns(4).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
                dataGridView1.Columns(4).Width = 80

                dataGridView1.Columns(5).HeaderText = "ファイル"
                dataGridView1.Columns(5).Width = 200
                dataGridView1.Columns(5).ReadOnly = True

                dataGridView1.Columns(6).HeaderText = "備考"
                dataGridView1.Columns(6).Width = 200
                dataGridView1.Columns(6).ReadOnly = False

                dataGridView1.Columns(7).HeaderText = "システム名"
                dataGridView1.Columns(7).Width = 80
                dataGridView1.Columns(7).ReadOnly = False
                dataGridView1.Columns(8).HeaderText = "伝No"
                dataGridView1.Columns(8).Width = 50
                dataGridView1.Columns(8).ReadOnly = False


                dataGridView1.Columns(9).HeaderText = "登録日"
                dataGridView1.Columns(9).ReadOnly = True
                dataGridView1.Columns(10).HeaderText = "登録端末"
                dataGridView1.Columns(10).ReadOnly = True
                dataGridView1.Columns(11).HeaderText = "処理区"
                dataGridView1.Columns(11).Width = 70
                dataGridView1.Columns(11).ReadOnly = True
                dataGridView1.Columns(12).HeaderText = "更新日"
                dataGridView1.Columns(12).ReadOnly = True
                dataGridView1.Columns(13).HeaderText = "更新端末"
                dataGridView1.Columns(13).ReadOnly = True


                '//奇数行のセルの背景色を替える
                dataGridView1.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(238, 236, 225)

                adapter.Dispose()
                Conn.Close()

            End Using

        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Return
        End Try


    End Sub


    Private Sub dataGridView1_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles dataGridView1.CellContentClick
        Dim w_col As Integer
        Dim w_row As Integer
        Dim w_str As String
        Dim ps As Process
        Dim w_long As Long

        w_col = e.ColumnIndex
        w_row = e.RowIndex
        If w_col = 5 Then
            w_str = dataGridView1.CurrentRow.Cells(5).Value
            '// MessageBox.Show(w_str);
            ps = New Process()
            w_str = 保存場所.Text & "\\" & w_str
            ps.StartInfo.FileName = w_str
            ps.Start()
        End If

        If w_col = 0 Then
            w_long = dataGridView1.CurrentRow.Cells(0).Value

            参照No.Text = w_long

            Dim f3 As Form = New Form3()
            f3.ShowDialog(Me)
            If f3.DialogResult = DialogResult.OK Then
                cmd_抽出.PerformClick()
                '修正したセルに戻す
                If dataGridView1.Rows.Count <> 0 Then
                    If w_row + 1 <= dataGridView1.Rows.Count Then
                        dataGridView1.CurrentCell = dataGridView1(0, w_row)
                    Else
                        dataGridView1.CurrentCell = dataGridView1(0, dataGridView1.Rows.Count - 1)
                    End If
                End If
            End If

            f3.Dispose()

        End If

    End Sub

    Private Sub btn_cal1_Click(sender As Object, e As EventArgs) Handles btn_cal1.Click
        Dim f_cal As Form = New F_カレンダー()

        If 取引日from.Text <> "" Then
            cal.p_ymd = DateTime.Parse(取引日from.Text)
        End If

        f_cal.StartPosition = FormStartPosition.CenterParent

        If DialogResult.OK = f_cal.ShowDialog(Me) Then
            Dim re_ymd As Date = cal.p_ymd
            取引日from.Text = re_ymd.ToString("yyyy/MM/dd")
        End If

        f_cal.Dispose()

    End Sub

    Private Sub btn_cal2_Click(sender As Object, e As EventArgs) Handles btn_cal2.Click
        Dim f_cal As Form = New F_カレンダー()

        If 取引日to.Text <> "" Then
            cal.p_ymd = DateTime.Parse(取引日to.Text)
        End If

        f_cal.StartPosition = FormStartPosition.CenterParent

        If DialogResult.OK = f_cal.ShowDialog(Me) Then
            Dim re_ymd As Date = cal.p_ymd
            取引日to.Text = re_ymd.ToString("yyyy/MM/dd")
        End If

        f_cal.Dispose()

    End Sub



    Private Sub cmd_閉じる_Click(sender As Object, e As EventArgs) Handles cmd_閉じる.Click

        Close()

    End Sub

    Private Sub Form2_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        Dim forward As Boolean

        If e.KeyCode = Keys.Enter Then
            ' Shiftキーが押されているかの判定
            forward = e.Modifiers <> Keys.Shift
            ' タブオーダー順で次のコントロールにフォーカスを移動
            Me.SelectNextControl(Me.ActiveControl, forward, True, True, True)
        End If
    End Sub

    Private Sub Form2_KeyPress(sender As Object, e As KeyPressEventArgs) Handles MyBase.KeyPress
        If e.KeyChar = ControlChars.Cr Then
            '[Enter]キーで音が出るので、キーイベントが処理されたことにして音を消す
            e.Handled = True
        End If
    End Sub

    Private Sub 金額from_Enter(sender As Object, e As EventArgs) Handles 金額from.Enter

        金額from.Text = CDbl(金額from.Text)

    End Sub

    Private Sub 金額from_Leave(sender As Object, e As EventArgs) Handles 金額from.Leave

        If Not IsNumeric(金額from.Text) Then
            金額from.Text = 0
        End If

        金額from.Text = Format(CDbl(金額from.Text), "#,##0")

    End Sub

    Private Sub 金額to_Enter(sender As Object, e As EventArgs) Handles 金額to.Enter

        金額to.Text = CDbl(金額to.Text)

    End Sub

    Private Sub 金額to_Leave(sender As Object, e As EventArgs) Handles 金額to.Leave
        If Not IsNumeric(金額to.Text) Then
            金額to.Text = 0
        End If
        金額to.Text = Format(CDbl(金額to.Text), "#,##0")

    End Sub

    Private Sub btn_excel_Click(sender As Object, e As EventArgs) Handles btn_excel.Click
        ' EXCEL関連オブジェクトの定義
        Dim objExcel As Object = Nothing                        ' Excel.Application
        Dim objWorkbooks As Object = Nothing                    ' Excel.Workbooks
        Dim objWbk As Object = Nothing                          ' Excel.Workbook
        Dim objSheet As Object = Nothing

        Dim xlCells As Object = Nothing
        Dim xlRange As Object = Nothing
        Dim xlCellStart As Object = Nothing
        Dim xlCellEnd As Object = Nothing

        Const cnsTitle = "電子帳票 Excel出力"

        ' Excel.Applicationのインスタンス生成(共通処理)
        If Not FP_GetExcelInstance(objExcel, cnsTitle) Then Exit Sub
        '-------------------------------------------------------------------------------------------

        Try
            objWorkbooks = objExcel.Workbooks
            objWbk = objWorkbooks.Add()
            objSheet = objWbk.Worksheets(1)
            xlCells = objSheet.Cells

            Dim dc As DataColumn
            Dim columnData(dt_rec.Rows.Count, 1) As Object
            Dim row As Integer = 1
            Dim col As Integer = 1

            For col = 1 To dt_rec.Columns.Count
                row = 1
                dc = dt_rec.Columns(col - 1)
                'ヘッダー行の出力
                xlCells(row, col).value = dataGridView1.Columns(col - 1).HeaderText

                row = row + 1

                ' 列データを配列に格納
                For i As Integer = 0 To dt_rec.Rows.Count - 1
                    columnData(i, 0) = String.Format(dt_rec.Rows(i)(col - 1))
                Next

                xlCellStart = xlCells(row, col)
                xlCellEnd = xlCells(row + dt_rec.Rows.Count - 1, col)
                xlRange = objSheet.Range(xlCellStart, xlCellEnd)

                ' Excel書式設定
                Select Case Type.GetTypeCode(dc.DataType)
                    Case TypeCode.String
                        xlRange.NumberFormatLocal = "@"
                    Case TypeCode.DateTime
                        xlRange.NumberFormatLocal = "yyyy/mm/dd"
                        'Case TypeCode.Decimal
                        '    xlRange.NumberFormatLocal = "#,###"
                End Select
                xlRange.value = columnData

            Next

            xlCells.EntireColumn.AutoFit()
            xlRange = objSheet.UsedRange
            xlRange.Borders.LineStyle = 1   'xlContinuous
            xlRange = objSheet.Range("1:1")

            objExcel.Visible = True

        Catch

            'objExcel.Quit()
            MessageBox.Show(Err.Description)
            Return

        Finally

            ' EXCEL解放
            ' COM解放(まとめて)
            Call GP_ReleaseComObject(xlCellStart)
            Call GP_ReleaseComObject(xlCellEnd)
            Call GP_ReleaseComObject(xlRange)
            Call GP_ReleaseComObject(xlCells)
            Call GP_ReleaseComObject(objSheet)
            Call GP_ReleaseComObject(objWbk)
            Call GP_ReleaseComObject(objWorkbooks)
            Call GP_ReleaseComObject(objExcel)

        End Try
    End Sub
    '***********************************************************************************************
    '   ■■■ 共通サブ処理 ■■■
    '***********************************************************************************************
    '* 処理名　：FP_GetExcelInstance
    '* 機能　　：Excel.Applicationのインスタンス生成
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：処理成否(Boolean)
    '* 引数　　：Arg1 = Excel.Application(Object)        ※Ref参照
    '* 　　　　　Arg2 = 処理タイトル(String)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2009年03月01日
    '* 作成者　：井上　治
    '* 更新日　：2017年04月23日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Function FP_GetExcelInstance(ByRef objExcelApp As Object,
                                         ByVal strTitle As String) As Boolean
        '-------------------------------------------------------------------------------------------
        Dim typType As Type = Type.GetTypeFromProgID(g_cnsExcelApplication) ' Type
        ' 取得失敗
        If typType Is Nothing Then
            MessageBox.Show("Excelがインストールされていません。", strTitle)
            Return False
        End If
        objExcelApp = Activator.CreateInstance(typType)
        ' Microsoft Excelを表示
        objExcelApp.Visible = True
        Return True
    End Function

    '***********************************************************************************************
    '* 処理名　：GP_ReleaseComObject
    '* 機能　　：COMオブジェクトの解放
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：Arg1 = 解放するCOMオブジェクト(Object)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2009年03月01日
    '* 作成者　：井上　治
    '* 更新日　：2009年03月01日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Sub GP_ReleaseComObject(ByRef objCOM As Object)
        '-------------------------------------------------------------------------------------------
        ' 明示的にCOMオブジェクトへの参照を解放する
        Try
            ' ランタイム呼び出し可能ラッパーの参照カウントをデクリメント
            If ((objCOM IsNot Nothing) AndAlso (Marshal.IsComObject(objCOM))) Then
                Marshal.FinalReleaseComObject(objCOM)
            End If
        Finally
            ' 参照を解除する
            objCOM = Nothing
        End Try
    End Sub

    Private Sub 取引先名_Leave(sender As Object, e As EventArgs) Handles 取引先名.Leave
        Dim w_str As String

        '全角文字に統一
        w_str = common.Nz(取引先名.Text, "")
        w_str = StrConv(w_str, vbWide)
        取引先名.Text = w_str

    End Sub

    Private Sub 支払先名_Leave(sender As Object, e As EventArgs) Handles 支払先名.Leave
        Dim w_str As String

        '全角文字に統一
        w_str = common.Nz(支払先名.Text, "")
        w_str = StrConv(w_str, vbWide)
        支払先名.Text = w_str

    End Sub

    Private Sub dataGridView1_CellFormatting(sender As Object, e As DataGridViewCellFormattingEventArgs) Handles dataGridView1.CellFormatting

        If dataGridView1.Columns(e.ColumnIndex).Name = "sysskbn" Then
            Dim val As String = e.Value
            'セルの値により、文字色を変更する
            Select Case val
                Case "削除"
                    e.CellStyle.ForeColor = Color.Red
                Case Else
                    e.CellStyle.ForeColor = Color.Black
            End Select
        End If


    End Sub

    Private Sub Form2_FormClosed(sender As Object, e As FormClosedEventArgs) Handles MyBase.FormClosed

        common.p_form2_flg = False

    End Sub
End Class