﻿Imports System.Data.Odbc
Imports System.Text

Public Class Form3
    Public con_str As String = ""
    Public acfile As String = ""

    Private Sub Form3_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim w_sql As String
        Dim w_str As String

        Dim oc As OdbcCommand
        Dim odr As OdbcDataReader

        Me.KeyPreview = True        'キーボードイベント取得

        ' データソース名セット
        Try
            '※ODBC接続文字列取得
            Dim sb1_1 As StringBuilder = New StringBuilder(300)
            Dim unused = common.GetPrivateProfileString("ODBC", "conn", "none", sb1_1, Convert.ToUInt32(sb1_1.Capacity), ".\eform.ini")
            If sb1_1.ToString <> "" Then
                con_str = sb1_1.ToString
            End If

            'Accessファイル
            Dim sb1_2 As StringBuilder = New StringBuilder(300)
            common.GetPrivateProfileString("ODBC", "acfile", "none", sb1_2, Convert.ToUInt32(sb1_2.Capacity), ".\eform.ini")
            If sb1_2.ToString <> "" Then
                acfile = sb1_2.ToString
            End If

            If con_str = "" And acfile <> "" Then
                con_str = "Driver={Microsoft Access Driver (*.mdb, *.accdb)};DBQ=" & acfile & "; Uid=; Pwd =;"
            End If

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            Close()
            'Return
        End Try

        Try
            Using Conn As New OdbcConnection(con_str)

                'コントロールテーブル参照
                w_sql = "SELECT * FROM ef_cnt_tbl"
                ' 読み込み
                Conn.Open()

                oc = New OdbcCommand(w_sql, Conn)
                odr = oc.ExecuteReader()
                While odr.Read() = True
                    Me.Text = "電子帳票更新 - " + odr("syamei")
                    保存場所.Text = odr("save_fold")

                    '背景色 Access側 10進数からRGB算出
                    Dim w_color = odr("bcolor")
                    Dim w_blue = Math.Truncate(w_color / 65536)
                    Dim w_green = Math.Truncate((w_color - 65536 * w_blue) / 256)
                    Dim w_red = w_color - (65536 * w_blue) - (256 * w_green)
                    Me.BackColor = System.Drawing.Color.FromArgb(w_red, w_green, w_blue)
                End While

                odr.Close()
                oc.Dispose()

                番号.Text = CType(Me.Owner, Form2).参照No.Text

            End Using

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            Close()
            'Return
        End Try

        '--- 取引先名・支払先名コンボデータソースセット
        comb_ini()

        '// --- データ取得・表示 -----------------
        w_sql = "SELECT * FROM eform_info_d WHERE rno=" & Convert.ToInt64(番号.Text)

        Dim connection = New OdbcConnection(con_str)

        connection.Open()

        oc = New OdbcCommand(w_sql, connection)
        odr = oc.ExecuteReader()
        While odr.Read() = True
            取引先名.Text = odr("torinm")
            支払先名.Text = odr("sihanm")
            金額.Text = CDbl(odr("kin")).ToString("#,##0")
            biko.Text = odr("biko")
            ファイル名.Text = odr("fnm")
            dateTimePicker1.Value = DateTime.Parse(odr("ymd"))
            システム名.Text = odr("sysnm")
            伝票No.Text = odr("sysdno")

            If odr("sysskbn") = "削除" Then
                lbl_del.Visible = True
            Else
                lbl_del.Visible = False
            End If

        End While

        odr.Close()
        oc.Dispose()

        connection.Close()

        w_str = 保存場所.Text & "\\" & ファイル名.Text

        'AxAcroPDF1.LoadFile(w_str)         'Load時に大きいPDFファイルを表示したら画面が崩れることがあったのでカット

        dateTimePicker1.Select()
        dateTimePicker1.Focus()


    End Sub

    Public Sub comb_ini()
        '--- 取引先名・支払先名のコンボのソースをeform_info_dのデータよりセット ---
        Dim w_sql As String
        Dim dt As DataTable
        Dim dt2 As DataTable

        Dim connection = New OdbcConnection(con_str)

        Dim adapter As OdbcDataAdapter

        'DB接続
        connection.Open()

        ' --- 取引先名 ---
        w_sql = "SELECT torinm FROM eform_info_d WHERE torinm <>'' GROUP BY torinm ORDER BY torinm"
        dt = New DataTable()

        '// 読み込み
        adapter = New OdbcDataAdapter(w_sql, connection)
        adapter.Fill(dt)

        取引先名.DataSource = dt    '// 取引先名コンボソース

        adapter.Dispose()

        'データ用の列を設定
        取引先名.ValueMember = "torinm"
        取引先名.Text = ""


        ' --- 支払先名 ---
        w_sql = "SELECT sihanm FROM eform_info_d WHERE sihanm <>'' GROUP BY sihanm ORDER BY sihanm"
        dt2 = New DataTable()

        '// 読み込み
        adapter = New OdbcDataAdapter(w_sql, connection)
        adapter.Fill(dt2)

        支払先名.DataSource = dt2    '// 支払先名取引先名コンボソース

        adapter.Dispose()

        'データ用の列を設定
        支払先名.ValueMember = "sihanm"
        支払先名.Text = ""

        ' --システム名 コンボ -----
        w_sql = "SELECT sysnm FROM eform_info_d WHERE  "
        w_sql &= " sysskbn <> '削除' "
        w_sql &= " GROUP BY sysnm ORDER BY sysnm"
        w_sql &= ";"
        dt2 = New DataTable()

        '// 読み込み
        adapter = New OdbcDataAdapter(w_sql, connection)
        adapter.Fill(dt2)

        システム名.DataSource = dt2    '// コンボソース

        adapter.Dispose()

        'データ用の列を設定
        システム名.ValueMember = "sysnm"
        システム名.Text = ""


        'DB切断
        connection.Close()


    End Sub

    Private Sub cmd_キャンセル_Click(sender As Object, e As EventArgs) Handles cmd_キャンセル.Click

        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel

        Close()

    End Sub

    Private Sub cmd_更新_Click(sender As Object, e As EventArgs) Handles cmd_更新.Click

        Dim res As String
        Dim w_sql As String
        Dim w_dt As DateTime
        Dim result As String
        Dim machine As String

        Dim cmd As OdbcCommand

        'Null値対策
        取引先名.Text = common.Nz(取引先名.Text, "")
        支払先名.Text = common.Nz(支払先名.Text, "")
        biko.Text = common.Nz(biko.Text, "")
        システム名.Text = common.Nz(システム名.Text, "")
        伝票No.Text = common.Nz(伝票No.Text, "")

        '// 入力チェック
        If 取引先名.Text = "" Then
            res = MsgBox("取引先は省略できません。", vbExclamation)
            Exit Sub
        End If

        Try
            Using Conn As New OdbcConnection(con_str)
                'DB接続
                Conn.Open()

                w_sql = "UPDATE eform_info_d SET ymd='" & dateTimePicker1.Value.ToString("yyyy/MM/dd") & "' "
                w_sql = w_sql & ",torinm='" & 取引先名.Text & "',sihanm='" & 支払先名.Text & "' "
                w_sql = w_sql & ",kin=" & CDbl(金額.Text) & ",biko='" & biko.Text & "' "
                w_sql = w_sql & ",sysskbn='修正' "
                w_dt = Now
                result = w_dt.ToString()
                machine = Environment.MachineName
                w_sql = w_sql & ",upymd='" & result & "',upterm='" & machine & "_VB' "
                w_sql = w_sql & ",sysnm='" & システム名.Text & "',sysdno='" & 伝票No.Text & "' "
                w_sql = w_sql & " WHERE rno=" & Convert.ToInt64(番号.Text)

                cmd = New OdbcCommand(w_sql, Conn)
                res = cmd.ExecuteNonQuery()

                cmd.Dispose()
                Conn.Close()

                res = MsgBox("更新しました。", vbInformation)

                '正常更新時はDialogResult.OKを設定する。
                Me.DialogResult = System.Windows.Forms.DialogResult.OK

                Close()
            End Using

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            'Close()
            Return

        End Try


    End Sub

    Private Sub btn_日付参照_Click(sender As Object, e As EventArgs) Handles btn_日付参照.Click
        Dim f_cal As Form = New F_カレンダー()

        cal.p_ymd = dateTimePicker1.Value
        f_cal.StartPosition = FormStartPosition.CenterParent

        If DialogResult.OK = f_cal.ShowDialog(Me) Then
            Dim re_ymd As Date = cal.p_ymd
            dateTimePicker1.Value = re_ymd
        End If

        f_cal.Dispose()

    End Sub

    Private Sub Form3_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        Dim forward As Boolean

        If e.KeyCode = Keys.Enter Then
            ' Shiftキーが押されているかの判定
            forward = e.Modifiers <> Keys.Shift
            ' タブオーダー順で次のコントロールにフォーカスを移動
            Me.SelectNextControl(Me.ActiveControl, forward, True, True, True)
        End If
    End Sub

    Private Sub Form3_KeyPress(sender As Object, e As KeyPressEventArgs) Handles MyBase.KeyPress
        If e.KeyChar = ControlChars.Cr Then
            '[Enter]キーで音が出るので、キーイベントが処理されたことにして音を消す
            e.Handled = True
        End If
    End Sub

    Private Sub 金額_Enter(sender As Object, e As EventArgs) Handles 金額.Enter

        金額.Text = CDbl(金額.Text)

    End Sub

    Private Sub 金額_Leave(sender As Object, e As EventArgs) Handles 金額.Leave

        If Not IsNumeric(金額.Text) Then
            金額.Text = 0
        End If

        金額.Text = Format(CDbl(金額.Text), "#,##0")

    End Sub

    Private Sub 取引先名_Leave(sender As Object, e As EventArgs) Handles 取引先名.Leave
        Dim w_str As String

        '全角文字に統一
        w_str = common.Nz(取引先名.Text, "")
        w_str = StrConv(w_str, vbWide)
        取引先名.Text = w_str

    End Sub

    Private Sub 支払先名_Leave(sender As Object, e As EventArgs) Handles 支払先名.Leave
        Dim w_str As String

        '全角文字に統一
        w_str = common.Nz(支払先名.Text, "")
        w_str = StrConv(w_str, vbWide)
        支払先名.Text = w_str

    End Sub

    Private Sub cmd_削除_Click(sender As Object, e As EventArgs) Handles cmd_削除.Click
        Dim res As String
        Dim w_sql As String
        Dim w_dt As DateTime
        Dim result As String
        Dim machine As String

        Dim cmd As OdbcCommand


        res = MsgBox("削除設定をしてよろしいですか？（物理的な削除はしません。非表示になるだけです。）", vbExclamation + vbYesNo)
        If res = vbNo Then
            Exit Sub
        End If


        Try
            Using Conn As New OdbcConnection(con_str)
                'DB接続
                Conn.Open()

                w_sql = "UPDATE eform_info_d SET "
                w_sql = w_sql & " sysskbn='削除' "
                w_dt = Now
                result = w_dt.ToString()
                machine = Environment.MachineName
                w_sql = w_sql & ",upymd='" & result & "',upterm='" & machine & "_VB' "
                w_sql = w_sql & " WHERE rno=" & Convert.ToInt64(番号.Text)

                cmd = New OdbcCommand(w_sql, Conn)
                res = cmd.ExecuteNonQuery()

                cmd.Dispose()
                Conn.Close()

                res = MsgBox("削除を設定しました。", vbInformation)

                '正常更新時はDialogResult.OKを設定する。
                Me.DialogResult = System.Windows.Forms.DialogResult.OK

                Close()
            End Using

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            'Close()
            Return

        End Try
    End Sub

    Private Sub btn_pdfdsp_Click(sender As Object, e As EventArgs) Handles btn_pdfdsp.Click
        Dim w_str As String

        w_str = 保存場所.Text & "\\" & ファイル名.Text
        AxAcroPDF1.LoadFile(w_str)

    End Sub
End Class