﻿Imports System.Runtime.InteropServices
Imports System.Security.Cryptography
Imports System.Text

Public Class common
    '検索項目値　受け渡し用
    Public Shared p_tkcd As String
    Public Shared p_ym As String
    Public Shared p_no As Integer

    '画面重複起動防止フラグ
    Public Shared p_form1_flg As Boolean = False
    Public Shared p_form2_flg As Boolean = False

    <DllImport("KERNEL32.DLL", CharSet:=CharSet.Auto)>
    Public Shared Function GetPrivateProfileString(
                             ByVal lpAppName As String,
                             ByVal lpKeyName As String,
                             ByVal lpDefault As String,
                             ByVal lpReturnedString As StringBuilder,
                             ByVal nSize As Integer,
                             ByVal lpFileName As String) As Integer
    End Function

    <DllImport("KERNEL32.DLL", CharSet:=CharSet.Auto)>
    Public Shared Function WritePrivateProfileString(
                              ByVal lpApplicationName As String,
                              ByVal lpKeyName As String,
                              ByVal lpString As String,
                              ByVal lpFileName As StringBuilder) As Integer
    End Function

    Public Shared Function MidShift(in_str As String, in_st As Integer, in_ed As Integer) As String
        '--- 半角1桁全角２桁計算で混在文字列を切り出します。str:文字列、st:開始位置,ed:終了位置
        Dim InputString As String
        Dim Pos As Integer
        Dim Len As Integer
        Dim lenSum As Integer
        Dim sb As New Text.StringBuilder

        InputString = in_str

        For Pos = 0 To InputString.Length - 1

            Len = Encoding.GetEncoding("Shift_JIS").GetByteCount(InputString.Substring(Pos, 1))

            lenSum += Len

            If lenSum >= in_st And lenSum <= in_ed Then
                sb.Append(InputString.Substring(Pos, 1))
            End If

        Next

        MidShift = sb.ToString

    End Function

    ''' オブジェクトが Nothing または DBNull の場合に長さ 0 の文字列("")または指定したその他の値を返す
    ''' <param name="Value">対象となるオブジェクト</param>
    ''' <param name="ValueIfNull">Nothing または DBNull のときに返す値を指定、長さ 0 の文字列("")以外の値を返す場合に指定</param>
    ''' <returns>長さ 0 の文字列("")または、指定したその他の値</returns>
    ''' <remarks>AccessのNz関数をVB.NET版として作成。ただし数値の場合は ValueIfNull に 0 を指定しないと長さ 0 の文字列("")を返す</remarks>
    Public Shared Function Nz(ByVal Value As Object,
                          Optional ByVal ValueIfNull As Object = Nothing) As String

        Nz = ""

        Dim res As Object

        If ValueIfNull Is Nothing Then
            res = Space(0)
        Else
            res = ValueIfNull
        End If

        If IsDBNull(Value) Or Value Is Nothing Then
            Nz = res
        Else
            Nz = Value.ToString()
        End If

    End Function

    Public Shared Function GetFHashValue(str1 As String) As String
        'SHA1ハッシュ値を計算するファイル 
        Dim fileName As String = str1
        'ファイルを開く 
        Dim fs As New System.IO.FileStream(fileName,
            System.IO.FileMode.Open, System.IO.FileAccess.Read)

        'SHA1CryptoServiceProviderオブジェクトを作成 
        Dim sha1 As System.Security.Cryptography.SHA1 =
            System.Security.Cryptography.SHA1.Create()

        'ハッシュ値を計算する 
        Dim bs As Byte() = sha1.ComputeHash(fs)

        'リソースを解放する
        sha1.Clear()
        'ファイルを閉じる 
        fs.Close()

        'byte型配列を16進数の文字列に変換 
        Dim str2 As String = BitConverter.ToString(bs).ToLower().Replace("-", "")

        Return str2.ToString

    End Function

End Class
